From 28da250d243949be488964ffffeb1c4962285611 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Jul 30 2020 01:41:43 +0000
Subject: [PATCH 663/2232] Merge pull request #242 from dtolnay/str-ptr-len


Add rust::String(const char *, size_t) constructor
---

diff --git a/include/cxx.h b/include/cxx.h
index f211b3b..c3231fd 100644
--- a/include/cxx.h
+++ b/include/cxx.h
@@ -29,6 +29,7 @@ public:
 
   String(const std::string &);
   String(const char *);
+  String(const char *, size_t);
 
   String &operator=(const String &) noexcept;
   String &operator=(String &&) noexcept;
@@ -58,6 +59,7 @@ public:
 
   Str(const std::string &);
   Str(const char *);
+  Str(const char *, size_t);
   Str(std::string &&) = delete;
 
   Str &operator=(Str) noexcept;
diff --git a/src/cxx.cc b/src/cxx.cc
index eb86d3d..da05ee2 100644
--- a/src/cxx.cc
+++ b/src/cxx.cc
@@ -55,16 +55,11 @@ String::String(String &&other) noexcept {
 
 String::~String() noexcept { cxxbridge03$string$drop(this); }
 
-String::String(const std::string &s) {
-  auto ptr = s.data();
-  auto len = s.length();
-  if (!cxxbridge03$string$from(this, ptr, len)) {
-    panic<std::invalid_argument>("data for rust::String is not utf-8");
-  }
-}
+String::String(const std::string &s) : String(s.data(), s.length()) {}
 
-String::String(const char *s) {
-  auto len = std::strlen(s);
+String::String(const char *s) : String(s, std::strlen(s)) {}
+
+String::String(const char *s, size_t len) {
   if (!cxxbridge03$string$from(this, s, len)) {
     panic<std::invalid_argument>("data for rust::String is not utf-8");
   }
@@ -111,13 +106,11 @@ Str::Str() noexcept : repr(Repr{reinterpret_cast<const char *>(this), 0}) {}
 
 Str::Str(const Str &) noexcept = default;
 
-Str::Str(const std::string &s) : repr(Repr{s.data(), s.length()}) {
-  if (!cxxbridge03$str$valid(this->repr.ptr, this->repr.len)) {
-    panic<std::invalid_argument>("data for rust::Str is not utf-8");
-  }
-}
+Str::Str(const std::string &s) : Str(s.data(), s.length()) {}
+
+Str::Str(const char *s) : Str(s, std::strlen(s)) {}
 
-Str::Str(const char *s) : repr(Repr{s, std::strlen(s)}) {
+Str::Str(const char *s, size_t len) : repr(Repr{s, len}) {
   if (!cxxbridge03$str$valid(this->repr.ptr, this->repr.len)) {
     panic<std::invalid_argument>("data for rust::Str is not utf-8");
   }

